<?php
#
# Copyright(C) 2006-2007 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

require_once('defs.php');

#
# Display acls in html
# print html to display the list of acls, with dnd
#
# $id_tab: array of acls id, indexed by order
# $policy: session policy
# $hidden_inputs: inputs fields to be added to forms
$s_ret = "";
function display_acls_dnd($id_tab, $policy, $hidden_inputs, $sbichain){
    ksort($id_tab);
    $bichains = unserialize($_SESSION['bichains']);
    $used_desc = $_SESSION['used_desc'];
    //var_dump($bichains);
    $b_from = null;
    $b_to = null;
    foreach($bichains as $bichain){
        if ($bichain['label'] == $sbichain){
            $b_from = $bichain['from'];
            $b_to = $bichain['to'];
        }
    }
    if($b_from == null && $b_to == null){
        return;
    }
    foreach ($id_tab as $order=>$id){
        //print "  <tr><td><a href=\"acls.php?acl=$id\">$desc</a></td><td><a href=\"acls.php?macl=$id&up=1\"><img src=\"up.gif\" alt=up border=no></a></td><td><a href=\"acls.php?macl=$id&down=1\"><img src=\"down.gif\" alt=\"down\" border=\"no\"></td></tr>\n";
        //print "  <div id=\"dnd$id\"><a href=\"acls.php?acl=$id\">$desc</a></td><td><a href=\"acls.php?macl=$id&up=1\"><img src=\"up.gif\" alt=up border=no></a></td><td><a href=\"acls.php?macl=$id&down=1\"><img src=\"down.gif\" alt=\"down\" border=\"no\"></div>\n";
        $acls = $policy->acls;
        $groups = $policy->groups;
        $subjects = $policy->subjects;
        //$id = $id_tab[$order];
        $dacl = $acls->get_elt_by_id($id);
        $acl_order = $dacl->get_order($used_desc, $b_from, $b_to);
        $desc = $dacl->name;
        //if(!isset($aclorder))
        //$dacl = $acls->get_elt($id);
        $ddecision = $dacl->decision;
        $class_dec=$dacl->decision;
        $mygrp = $groups->get_elt($dacl->group);
        $enabled=$mygrp->enabled;
        $dname = $dacl->name;
        $acl_title = html_acl_resume($dacl, $policy);
        $idp = sprintf("[%03s]",$id);
        $detail_form= '<input type="hidden" name="acl" value="'.$id.'" />'.
            '<input type="hidden" name="dndSort" value="" />'.
            $hidden_inputs.
            '<div class=detail><input type="submit" value="Detail" class="input1 '.$class_dec.'" title="'.$class_dec.'"/></div>'.
            '</form>';
        if ($enabled == 1)
        {
            $strong='<strong>';
            $strongend='</strong>';
            $span='enabled';
        }
        else
        {
            $strong='';
            $strongend='';
            $span='disabled';
        }

        $s_ret .= "  <li id=\"$acl_order\">\n";
        $s_ret .= '<form action="acls.php" method="post" class="acldetail" onsubmit="aclHandle(bichains_t)">';
        $s_ret .= "<div title=\"$acl_title\" class=\"sort\" id=\"$acl_order\">\n<div class=\"$span\">\n$strong$idp";
        $s_ret .= "<img src=\"images/".$mygrp->ID.".png\" height=15>$strongend $desc\n</div><!-- $span --> \n";
        //$s_ret .="<div class=\"updown\">";
        //$s_ret .= "<a href=\"acls.php?macl=$id&up=1\"><img src=\"up.gif\" alt=up border=no></a><a href=\"acls.php?macl=$id&down=1\"><img src=\"down.gif\" alt=\"down\" border=\"no\"></a>"
        $s_ret .="$detail_form</div></li>\n";
    }
    //print "</table>\n";
    return $s_ret;
}#end display acls dnd


#
# display networks chains
#
function display_chains($policy, $used_desc){
    $s = '';
    $descs = $policy->descs;
    #print "used_desc: $used_desc";
    $desc = $descs->elts[$used_desc];
    #var_dump($desc);
    $networks = $desc->elts;
    $s .= "<h2>Bichains</h2>";
    foreach($networks as $key=>$network){
        $data = $network->datas;
        $s .= "<li>";
        $s .= $data['name'];
        $s .= "</li>";
    }
    return $s;
}


function print_javascript($code){
    print '<script  type="text/javascript">'."\n";
    print $code."\n";
    print "</script>\n";
}


function js_bichain_array($bichains){
    $s = 'var bichains_t = Array(\'bi_BICHAIN\'';
    /*foreach ($bichains as $id => $bichain){
        $c = $bichain['label'];
        $s .= "'bi_$c',";
    }*/
    $s = preg_replace('/,$/','',$s);
    $s .= ');';

    return $s;
}

#javascript code to run on page load
function print_acls_onload($bichains, $used_bichain){
    #var_dump($bichains);
    #print "disp_bichain: $used_bichain\n";
    $s = js_bichain_array($bichains);
    $show_bichain = $bichains[$used_bichain];
    $s_show = '';
    if (isset($show_bichain)){
        $v = $show_bichain['label'];
        $s_show = "show('bi_$v');";
    }
    $s_fun = "
window.onload = function() {
    /*hide_all(bichains_t);*/
    init_acls_dnd(Array('bi_BICHAIN'));
    /*$s_show*/
}";
    print_javascript("$s\n$s_fun\n");
}



#
# Create javascript code to enable D&D for chains and INPUT/OUTPUT
#
function acls_dnd_init($chains){
    #$chains = get_chains($policy, $used_desc);
    global $mess_bichains_title;
    $s_dd = '';
    $s_cons = '';
    $s_targets = "
t1 = new YAHOO.util.DDTarget('dir_in', 'IN');
t2 = new YAHOO.util.DDTarget('dir_out', 'OUT');
targets_dnd_array.push(t1);
targets_dnd_array.push(t2);
";

    $i = 1;
    foreach($chains as $chain){
        $dd_name = "dd$i";
        $s_dd .= "$dd_name = new YAHOO.example.DDPlayer('d_$chain','IN');\n";
        $s_dd .= "$dd_name.addToGroup('OUT');\n";
        $s_dd .= "bichains_dnd_array.push($dd_name);\n";

        $s_cons .= "c$i = new Consumer('consumer$i', $dd_name);\n";

        $i++;
    }


    $s = "
var AjaxAclObj = {
    handleSuccess:function(o){
        var div = document.getElementById('c1');
        div.innerHTML = o.responseText + '<br />';
        init_acls_dnd(Array('bi_BICHAIN'));
    },

    handleFailure:function(o){
        alert(o.getResponseHeader['EDW-Message']);
    }


};

var callback1 =
{
    success:AjaxAclObj.handleSuccess,
    failure:AjaxAclObj.handleFailure,
    scope: AjaxAclObj
};
var bichains_dnd_array = Array();
var targets_dnd_array = Array();
var coincoin = null;
YAHOO.example.DDApp = function() {;\n";
    $s.="
    var dd, dd2;
    var t1, t2;
    var c1,c2;
    return {
        init: function(){
            YAHOO.namespace('example.panel_bichains');
            YAHOO.example.panel_bichains.dlg = new YAHOO.widget.Dialog('panel_bichains', {
                visible: false,
                draggable: false,
                close: false,
                modal: true,
                context: ['show_bichains', 'tl', 'tl']
            });
            test = YAHOO.example.panel_bichains.dlg.render();
            YAHOO.example.panel_bichains.dlg2 = new YAHOO.widget.Panel('acl_bichain_list', {
                context: ['show_acl_bichains', 'tl', 'tr'],
                visible: false,
                close: false,
                draggable: false
            });
            /*YAHOO.example.panel_bichains.dlg.setHeader('$mess_bichains_title');*/
            test = YAHOO.example.panel_bichains.dlg2.render();
            YAHOO.example.panel_bichains.mgr = new YAHOO.widget.OverlayManager( { overlays:[YAHOO.example.panel_bichains.dlg, YAHOO.example.panel_bichains.dlg2] } );
            $s_targets
            $s_dd
            $s_cons
        }

    }
} ();
YAHOO.util.Event.addListener(window, 'load', YAHOO.example.DDApp.init);
";

return $s;

}

function print_chains_dnd($chains){
    $i = 0;
    $s = "<div class=\"chains\">\n";
    foreach($chains as $chain){
        $s .= "<div id=\"d_$chain\" class=\"drag\">";
        $s .= "$chain";
        $s .= "</div>\n";
        $i++;
    }
    $s .= "</div>\n";

    print $s;
}

function print_targets_inout(){
    $s = '
<br />
<div id="2" class="targets">
<div id="dir_in" class="target">
IN
</div>
<div id="dir_out" class="target">
OUT
</div>
</div>
<div id="inout">
</div>

';
    print $s;
}

/* print hidden inputs for dndSort_BICHAIN */
function dndsort_inputs($bichains){
    $s = '';
    if (is_array($bichains))
    {
      foreach($bichains as $bichain){
        $name = $bichain['label'];
        $s .= "<input type=\"hidden\" name=\"dndSort_$name\" value=\"\" />\n";
      }
    }
    return $s;
}

# display acls of one bichain
function html_acls_bichain($bichain_id, $bichains, $expolicy){
    global $gal_save_acl_order, $gal_initial_acl_order;
    global $used_desc;
    /*echo "$bichain_id";
    var_dump($bichains);*/
    $acls = $expolicy->acls;
    $bichain_obj = $bichains[$bichain_id];
    $bichain_label = $bichain_obj['label'];
    $dndSorts = "<input name=\"dndSort_BICHAIN\" value=\"\" type=\"hidden\">";
#
# Get acls in bichain
    $glob_id_tab = array();
    $id_tab = array();
    $ress2=array();
    $disp_bichain = $bichain_id;
    $tbichain = $bichains[$disp_bichain];
    foreach ($acls->elts as $dacl)
    {
        $desc = $dacl->name;
        /*echo $desc, " ", $dacl->ID, "<br />";*/
        if (bichain_touches_acl($tbichain,$dacl)){
            $bichain = $tbichain;
            $order = $dacl->get_order($used_desc, $bichain['from'], $bichain['to']);
            $ress2[$order]=$desc;
            $id_tab[$order]=$dacl->ID;
        }
    }
    $glob_id_tab[$tbichain['label']] = $id_tab;

#
# Display acls in html
# acls of one bichain
#
    $mybichain=$mybichain['label'];
    $acl_order_form = '<form onsubmit="aclHandle(bichains_t)" action="acls.php" method="post" style="clear:both;">'."\n".
#'<p><input type="hidden" id="dndSort" name="dndSort" value="" />'."\n".
        $dndSorts.
#'<input type="hidden" id="bichain" name="bichain" value="'.$mybichain.'">'."\n".
        '<input type="submit" class="submit" value="'.$gal_save_acl_order.'" />'."\n".
        '&nbsp<input class="inspector" type="button" value="'.$gal_initial_acl_order.'" onclick="resetOrder(\'sortcat\')"/></p>'.
        '</form>';
    $hidden_inputs = $dndSorts;
#echo $acl_order_form;
    if (!isset($ress))
    {
        $ress=array();
    }
    $s_ret = "";
# display acls by bichain
    foreach($glob_id_tab as $tbichain => $id_tab){
        if (isset($tbichain)){
            $hidden_inputs .= "\n".'<input type="hidden" id="bichain" name="bichain" value="'.$tbichain.'">';
            $acl_order_form = '<form onsubmit="aclHandle(bichains_t)" action="acls.php" method="post" style="clear:both;">'."\n".
#'<p><input type="hidden" id="dndSort" name="dndSort" value="" />'."\n".
                $hidden_inputs.
#'<input type="hidden" id="bichain" name="bichain" value="'.$mybichain.'">'."\n".
                '<input type="submit" class="submit" value="'.$gal_save_acl_order.'" />'."\n".
                '&nbsp<input class="inspector" type="button" value="'.$gal_initial_acl_order.'" onclick="resetOrder(\'sortcat\')"/></p>'.
                '<input type="hidden" name="acl" value=""/>'.
                '</form>';
            $s_ret .= "<div id=\"bi_BICHAIN\" class=\"bichain\">\n";
            $s_ret .= $acl_order_form;
            $s_ret .= "<h2>$tbichain</h2>";
#display acls in bichain
            /*$s_ret .= "\n".'<ul id="sortcat_BICHAIN" class="sortcat sortul">'."\n";*/
            $s_ret .= "\n".'<ul id="sortcat" class="sortcat sortul">'."\n";
            $s_ret .= display_acls_dnd($id_tab, $expolicy, $hidden_inputs, $tbichain);
            $s_ret .= "</ul>\n";
            $s_ret .= $acl_order_form;
            $s_ret .= "</div>\n";
            $s_ret .= "\n\n";
        }
    }
    return $s_ret;
}


# print all acls
# do not enable javascript
function html_all_acls($policy, $net_from = null, $net_to = null, $show_grp=null){
    global $mess_no_reorder;
    global $gal_save_acl_order, $gal_initial_acl_order;

    $used_desc = $_SESSION['used_desc'];
    $descs = $policy->descs;
    $desc = $descs->elts[$used_desc];

    $args_net = Array('from' => $net_from, 'to' => $net_to);
    $nets_id = Array('from' => null, 'to' => null);
    $nets_name = Array('from' => null, 'to' => null);

    $title_acls = 'Acls';

    $hidden_inputs = "<input type=\"hidden\" name=\"chainfrom\" value=\"$net_from\">\n";
    $hidden_inputs .= "<input type=\"hidden\" name=\"chainto\" value=\"$net_to\">\n";
    # get id of networks for ALL-X or X-ALL display
    foreach (Array('from', 'to') as $direction){
        $net_s = $args_net[$direction];
        if (isset($net_s) and ($net_s != null) and ($net_s!="")){
            $net_obj = $desc->get_net_by_name($net_s);
            /*var_dump($net_obj);*/
            if ($net_s == 'LOCAL')
            {
              $nets_id[$direction]=-1;
              $nets_name[$direction]='LOCAL';
            }
            if ($net_obj != null){
                if (isset($net_obj->datas['id']))
                {
                   $nets_id[$direction] = $net_obj->datas['id'];
                }else if (isset($net_obj->datas['ID']))
                {
                   $nets_id[$direction] = $net_obj->datas['ID'];
                }
                /*echo "$direction ID: $net_id";*/
                $nets_name[$direction] = $net_obj->datas['name'];
            }
        }
    }
    if ($net_from != null){
        $title_acls .= " ".$nets_name['from'].'-ALL';
    }
    if ($net_to != null){
        $title_acls .= ' ALL-'.$nets_name['to'];
    }
    $acls = $policy->acls;
    $groups = $policy->groups;
    if($show_grp != null){
        $grp = $groups->get_elt($show_grp);
        $title_acls .= " (".$grp->name.")";
    }
    $acl_order_form = '<form action="acls.php" method="post" style="clear:both;">'."\n"
        .'<input type="submit" class="submit" value="'.$gal_save_acl_order.'" />'."\n".
        '&nbsp<input class="inspector" type="button" value="'.$gal_initial_acl_order.'" onclick="resetOrder(\'sortcat\')"/></p>'.
        '</form>';

    $s_ret .= "<div id=\"all_acls\" class=\"bichain\">\n";
    $s_ret .= "$mess_no_reorder.";
    $s_ret .= "<h2>$title_acls</h2>";
    /*$s_ret .= "\n".'<ul id="sortcat_'.$tbichain.'" class="sortcat sortul">'."\n";*/
    $s_ret .= "\n".'<ul id="chain" class="sortcat sortul">'."\n";
    foreach ($acls->ordered_list_tab() as $id => $descacl){
        $acl = $acls->get_elt_by_id($id);
        $acl_title = html_acl_resume($acl, $policy);
        # filter acls in case of ALL-X or X-ALL bichains
        if($nets_id['from'] != null and !acl_touches_network($acl, 'from', $nets_id['from'])) {continue;}
        if($nets_id['to'] != null and !acl_touches_network($acl, 'to', $nets_id['to'])) {continue;}
        if($show_grp != null and $acl->group != $show_grp){continue;}
        $mygrp = $groups->get_elt($acl->group);
        $desc = $acl->name;
        $enabled=$mygrp->enabled;
        $class_dec=$acl->decision;
        if ($enabled == 1){
            $strong='<strong>';
            $strongend='</strong>';
            $span='enabled';
        }else{
            $strong='';
            $strongend='';
            $span='disabled';
        }

        $idp = sprintf("[%03s]", $id);
        $s_ret .= "\n  <li id=\"$id\">\n".
            '<form action="acls.php" method="post" class="acldetail">'.
            "\n<div class=\"sort\" title=\"$acl_title\" style=\"cursor:auto;\" id=\"$id\">
            <div class=\"$span\">$strong$idp";
        $s_ret .= "<img src=\"images/".$mygrp->ID.".png\" height=15>$strongend $desc</div> <!-- $span -->\n";
        $detail_form=
            '<input type="hidden" name="acl" value="'.$id.'" />'.
            $hidden_inputs.
            '<div class=detail><input type="submit" value="Detail" class="input1 '.$class_dec.'" title="'.$class_dec.'"/></div> <!-- detail -->'."\n".
            '</div> <!-- sort -->'."\n".'</form>'."\n";
        $s_ret .= $detail_form;
        $s_ret .= "</li>" ;
    }
    $s_ret .= "</ul>\n";
    $s_ret .= "</div><!-- all_acls -->\n";


    return $s_ret;
}

# print list of acls's bichains
function html_acl_get_bichains($acl, $bichains){
    /*echo "in html_acl_get_bichains"; var_dump($acl); var_dump($bichains);*/
    global $gal_confirm_change_order;
    echo "<ul class=\"flist\">";
    foreach ($bichains as $id => $data){
        $label = $data['label'];
        if (bichain_touches_acl($data,$acl)){
            echo "<li><a href=\"acls.php?bichain=$label\"";
            echo " onclick=\"if (ask_list_change(new Array('sortcat'),'$gal_confirm_change_order')){ YAHOO.util.Connect.asyncRequest('GET', 'aclajax.php?bichain=$label', callback1,'bichain=INTRANET-DMZ');} return false;\">$label</a></li>";
        }
    }
    echo "</ul>";
}

/*
 return textual representatin of acl
*/
function html_acl_resume($acl, $policy){
    $subjects = $policy->subjects;
    $ressources = $policy->ressources;
    $protocols = $policy->protocols;
    $periods = $policy->periods;

    $subject = $subjects->get_elt($acl->from);
    $ressource = $ressources->get_elt($acl->to);
    $period = $periods->get_elt($acl->period);
    $protocol = $protocols->get_elt($acl->proto);
    $s_ret = $subject->name." -> ".$ressource->name;
    if(isset($protocol)){
        $s_ret .= ", ".$protocol->name;
    }
    if(isset($period)){
        $s_ret .= " @".$period->name;
    }

    return $s_ret;
}
?>
