<?php
#
# Copyright(C) 2004-2006 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">
<html><head>
<title>Nuface - <?php echo $title; ?> page</title>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-15" />
<meta http-equiv="refresh" content="900">
<link rel="stylesheet" type="text/css" href="main.css" media="screen" />
<link rel="stylesheet" type="text/css" href="nuconf.css" media="screen" />
<link rel="stylesheet" type="text/css" href="js/yahoo/container/assets/container.css" media="screen" />
<?php
if ($edenwall_integration!=0){
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"../nuconf/style.css\" media=\"screen\" />\n";
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"../nuconf/edennavbar.css\" media=\"screen\" />\n";
}
$new_search=$_REQUEST['search'];
$case_sensitive=$_REQUEST['case_sensitive'];
?>

<script language="JavaScript" type="text/javascript" src="js/toolman/core.js"></script>
<script language="JavaScript" type="text/javascript" src="js/toolman/events.js"></script>
<script language="JavaScript" type="text/javascript" src="js/toolman/css.js"></script>
<script language="JavaScript" type="text/javascript" src="js/toolman/coordinates.js"></script>
<script language="JavaScript" type="text/javascript" src="js/toolman/drag.js"></script>
<script language="JavaScript" type="text/javascript" src="js/toolman/dragsort.js"></script>
<script language="JavaScript" type="text/javascript" src="js/toolman/cookies.js"></script>
<script language="JavaScript" type="text/javascript" src="js/menu.js"></script>


<script type="text/javascript" src="js/yahoo/yahoo/yahoo.js" ></script>
<script type="text/javascript" src="js/yahoo/event/event.js" ></script>
<script type="text/javascript" src="js/yahoo/dom/dom.js"></script>
<script type="text/javascript" src="js/yahoo/connection/connection.js"></script>
<script type="text/javascript" src="js/yahoo/logger/logger.js"></script>
<script type="text/javascript" src="js/yahoo/dragdrop/dragdrop.js" ></script>
<script type="text/javascript" src="js/yahoo/container/container.js" ></script>
<script type="text/javascript" src="js/DDPlayer.js" ></script>


<script  type="text/javascript" src="js/script.js"></script>
<?php
if ($lang_override)
{
  if (isset($_GET['lang']))
  {
    if (check_lang($_GET['lang']))
      $_SESSION['lang']=$_GET['lang'];
  }
}
if ($title == 'acls'){
  echo '<script language="JavaScript" type="text/javascript" src="js/acls.js"></script>'."\n";
}
if ($title == 'nat'){
  echo '<script language="JavaScript" type="text/javascript" src="js/nat.js"></script>'."\n";
}
?>
 <script type="text/javascript" src="js/fixed.js"></script>
</head>
<body>
<?php
require_once ("/etc/nuface/config.php");
require_once ("include/messages.php");
if ($edenwall_integration!=0)
  require_once ('../nuconf/include/edennavbar.php');
?>

<div class="headers">

<?php
$count=count($pages_list);
$url = $_SERVER['REQUEST_URI'];
$url = preg_replace(':/[a-z0-9_]+\.php.*:', '/index.php', $url);
echo "<div class=\"nufacelogo\"><a href=\"$url\"><img src=".$logo_nuface."></a></div>\n";
echo "<div class=\"nufaceheaders\">\n";
for ($i=0;$i<$count;$i++){
  $sep = ($i == $count - 1) ? '':'|';
  if (($pages_list[$i]) == $title){
       echo "<a href=\"".$pages_list[$i].".php\" class=\"highlight\" onclick=\"$header_onclick\">".$pages_display[$i]." </a> $sep ";
  } else {
       echo "<a href=\"".$pages_list[$i].".php\" onclick=\"$header_onclick\">".$pages_display[$i]."</a> $sep ";
  }
}
if ($lang_override)
{
  echo "<div class=\"langhead\">";
  foreach ($available_langs as $mylang)
  {
    if (isset($_SESSION['lang']))
    {
      if ($_SESSION['lang']!=$mylang)
      {
        print "<a href=\"?lang=$mylang\"><img border=0 src=\"images/$mylang.jpg\"></a> $sep";
      }
    }
  }
  echo "</div> <!-- langhead -->\n";
}
?>
<div class="subheaders">
<?php
#print "FOO";
#print_r($page);
    print "<table><tr>";
if (($title == 'subjects') or ($title == 'applications') or ($title == 'periods')){
  if ($nufw_firewall)
  {
    print "<td>";
    print $page{'new'}{$title}{$lang}." ".$page{$title}{$lang}." <form action=\"$title.php\" method=POST><input type=text size=20 name=name><input type=hidden name=new_$singtitle value=1><select name=op><option>or</option><option>and</option></select><input type=submit value=\"$gal_new\" class=\"button\"></form>";
    print "</td>";
  }else{
    print "<td>";
    print $page{'new'}{$title}{$lang}." ".$page{$title}{$lang}." <form action=\"$title.php\" method=POST><input type=text size=20 name=name><input type=hidden name=new_$singtitle value=1><input type=hidden name=op value=\"or\"><input type=submit value=\"$gal_new\" class=\"button\"></form>";
    print "</td>";
  }
} else if ($title == 'acls') {
  $acl_group = "";
  if (isset($_REQUEST['new_acl_group']) && preg_match('/^[0-9]*$/',$_REQUEST['new_acl_group'])) {
    $acl_group = $_REQUEST['new_acl_group'];
  }
  if (isset($_REQUEST['group']) && preg_match('/^[0-9]*$/',$_REQUEST['group'])) {
    $acl_group = $_REQUEST['group'];
  }
  print "<td>\n";
  print $page{'new'}{$title}{$lang}." ".$page{$title}{$lang}." <form action=\"$title.php\" method=POST><input type=text size=20 name=name><input type=hidden name=new_$singtitle value=1><input type=\"hidden\" name=\"new_acl_group\" value=\"$acl_group\"/><input type=submit value=\"$gal_new\" class=\"button\"></form>";
  print "</td><td>\n";
  print $page{'new'}{'group'}{$lang}." ".$string_group."<form action=\"$title.php\" method=POST><input type=text size=20 name=name><input type=hidden name=new_group value=1><input type=submit value=\"$gal_new\" class=\"button\"></form>";
  print "</td>";
  print "<td><input id=\"show_bichains\" type=\"button\" class=\"button\" onclick=\"if (ask_list_change(new Array('sortcat'),'$gal_confirm_change_order')){show_panel_bichains(); resetDnd();}\" value=\"$mess_show_bichains\" /></td>";
} else if (($title =='ressources') or ($title == 'protocols') or ($title == 'l7rules')) {
  print "<td>";
  print $page{'new'}{$title}{$lang}." ".$page{$title}{$lang}." <form action=\"$title.php\" method=POST><input type=text size=20 name=name><input type=hidden name=new_$singtitle value=1><input type=submit value=\"$gal_new\" class=\"button\"></form>";
  print "</td>";
} else if ($title=='nat') {
  print "<td>";
  print $page{'new'}{$title}{$lang}."<form action=\"$title.php\" method=POST><select name=\"nat_type\"><option>SNAT</option><option>DNAT</option><option>PNAT</option></select><input type=text size=20 name=new_nat><input type=submit value=\"$gal_new\" class=\"button\"></form>";
  print "</td>";
}

if (($title == 'ressources') or ($title == 'protocols') or ($title == 'subjects')
                            or ($title == 'subjects') or ($title == 'applications') or ($title == 'l7rules')) {
  print "<td>$mess_filter<form action=\"$title.php\" method=POST>$mess_case_sensitive<input type=\"checkbox\" name=\"case_sensitive\"";
  if (isset($case_sensitive) and (($case_sensitive=='on') or ($case_sensitive=='i'))) {
    print " CHECKED";
  }
  print "><input type=text size=20 name=search";
  if (isset($new_search)) {
    print " value=\"$new_search\"";
  }
  print "><input type=submit value=\"$mess_search\" class=\"button\"></form></td>";
}
print "</tr></table>";
?>
</div> <!-- subheaders -->
</div> <!-- nufaceheaders -->
</div> <!-- headers -->
