#!/bin/bash
#set -x
SCRIPT_NAME=`basename $0`
SCRIPT_DIR=`dirname $0`
SVN_URL=https://svn.inl.fr/inl-svn/technique/nuface/tests
TMP_DIR=/tmp/nupyf-tests

rm -rf "$TMP_DIR"
svn export "$SVN_URL" "$TMP_DIR" > /dev/null
for SUBDIR in "$TMP_DIR/"*/
do
  if [ -e "$SCRIPT_DIR"/`basename "$SUBDIR"` ]
  then
    echo "Warning: $SCRIPT_DIR/"`basename "$SUBDIR"`" already exists"
  else
    mv "$SUBDIR" "$SCRIPT_DIR"
  fi
done
rm -rf "$TMP_DIR"
