<?php

session_start();

require_once ("/etc/nuface/config.php");
require_once ("include/messages.php");
#require_once ("include/headers.php");
require_once ("include/function.php");
require_once ("include/types.php");
require_once ("include/display.php");

function edw_404_msg($msg){
    header("HTTP/1.0 404 Not Found");
    header("EDW-Message: $msg");
}

$expolicy=unserialize($_SESSION['document']);
$used_desc = $_SESSION['used_desc'];
$bichains = unserialize($_SESSION['bichains']);
$acls = $expolicy->acls;

# return error if no policy
if (!$expolicy){
    edw_404_msg($gal_load_valid_xml_file);
    exit(0);
}

# bichain
$disp_bichain = $_REQUEST['bichain'];
# args for X-ALL or ALL-X bichains
$chain_from = $_REQUEST['chainfrom'];
$chain_to = $_REQUEST['chainto'];

#
# validate  bichain
$valid_bichain = 0;
if (!isset($disp_bichain) or ($disp_bichain=='View All'))
{
  $valid_bichain = 1;
  $disp_bichain = 0;
}else{
  foreach($bichains as $key=>$data)
  {
    if (strcmp(($data['label']),$disp_bichain)!=0)
    {
      continue;
    }
    /*print "disp: $disp_bichain, label".$data['label'];*/
    $valid_bichain = 1;
    $disp_bichain = $key;
    break;
  }
}

# warning message for bad bichain
# only if chainfrom and chainto args are not set
if ($valid_bichain != 1 && !isset($chain_from) && !isset($chain_to)){
    edw_404_msg($mess_bad_bichain);
    exit(0);
}


/* display acls */
if (!isset($chain_from) && !isset($chain_to)){
    //var_dump($bichains);
    echo html_acls_bichain($disp_bichain, $bichains, $expolicy);
}elseif(isset($chain_from) || isset($chain_to)){
    echo html_all_acls($expolicy, $chain_from, $chain_to);
}

?>
